//------------------------------------------------------------------
// Random walk index developed by Micheal Poulos
// source : TASC 10:9 (385-389): Are There Persistent Cycles?
//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_maximum 3
#property indicator_buffers 3
#property indicator_color1  Green
#property indicator_color2  Red
#property indicator_color3  DarkSlateGray
#property indicator_style3  STYLE_DOT
#property indicator_width1  2
#property indicator_width2  2

//
//
//
//
//

extern int RWILength = 25;

double RWIUp[];
double RWIDown[];
double Zline[];
double ranges[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
      SetIndexBuffer(0,RWIUp);
      SetIndexBuffer(1,RWIDown);
      SetIndexBuffer(2,Zline);   SetIndexLabel(2,NULL);
   IndicatorShortName("Random walk index(experiment) ("+RWILength+")");
   return(0);
}
int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1);
           if (ArrayRange(ranges,0)!=Bars) ArrayResize(ranges,Bars);

   //
   //
   //
   //
   //
            
   for (i=limit, r=Bars-i-1; i>=0; i--,r++)
   {  
      ranges[r] = (fabs(Close[i+1]-iMA(NULL,0,RWILength,0,MODE_SMA,PRICE_CLOSE,i+1)));
         double rwiUp = 0;
         double rwiDo = 0;
         double atr   = ranges[r];
         
         for (int k = 1; k < RWILength; k++)
         {
            atr += ranges[r-k];  
            
            //
            //
            //
            //
            //
            
            double denominator  = (atr/(k+1.0))*MathSqrt(k+1);
               if (denominator != 0)
               {
                  rwiUp = MathMax(rwiUp,(Close[i]-iMA(NULL,0,RWILength,0,MODE_SMA,PRICE_CLOSE,i+k)) / denominator);
                  rwiDo = MathMax(rwiDo,(iMA(NULL,0,RWILength,0,MODE_SMA,PRICE_CLOSE,i+k)-Close[i]) / denominator);
               }
         }
         RWIUp[i]   = rwiUp;
         RWIDown[i] = rwiDo;
         Zline[i]   = 0.45;
   }         
   return(0);
}